
public class Set<P> {
	private Node<P> start;
	private int size;

	public Set() {
		this.start = null;
		this.size = 0;
	}

	public boolean isEmpty() { 								// Klasse fragt ab ob die liste leer ist
		if (size == 0) { 									// wenn l‰nge der liste 0 ist

			return true; 									// gibt true zur¸ck weil es boolean ist
		} else { 											// wenn oberes nicht erfÔøΩllt wird

			return false;									 // gibt false zur¸ck wegen boolean
		}
	}

	public void add(P wert) {								 // Methode f‰ngt hinten an die Liste etwas an
		this.size++;										 // grˆﬂe wird hochgez‰hlt da liste um ein grˆﬂer werden muss
		if (contains(wert) == false) {
			if (this.start == null) { 							// wenn start wert = 0 ist
				this.start = new Node<P>(wert);					 // start wird zu neuem Knoten mit wert wert
			} else {											 // wenn obere if bedingung nicht erf¸llt wird dann soll er volgendes
																 // ausgef¸hrt
				Node<P> current = this.start;					 // current bekommt den wert der start zugewissen wurde
				while (current.next != null) { 					 // w‰hrend nachfolger des jetzigen Knotens ungleich null ist
					current = current.next;						 // wird current dem n‰chsten werd zugewissen

				}
				current.next = new Node<P>(wert); // dem jetzigen Knoten wird als 2ter eintrag ein neuer Knoten
													// zugewissen
			}
		} else {
			return;
		}
	}

	public boolean contains(P wert) { // gibt aus ob ein wert in der Liste ist
		Node<P> current = this.start; // Knoten current wird der wert start zugewissen
		while (current != null) { // solange current ungleich null ist wird das in der Schleife ausgefÔøΩhrt

			if (current.wert == wert) { // wenn der der Knoten current = der wert ist

				return true; // dann gibt es den eintrag also muss er true zurÔøΩckgeben
			}
			current = current.next; // n‰chster wert wird zum aktuellen

		}

		return false; // sonst ist er nicht drin
	}

	public void remove(P wert) {
		Node<P> current = this.start; 				// neuer Knoten current wird erstellt
		if (current.wert == wert) {					//wenn der wert in current gleich der wert ist 
			this.start = current.next;				//wenn der wert von start wird auf den wert im nchsten Node ist 
		}
		while (current.next != null) {				//solange der nchste wert in Node ungleich null ist 
			if (current.next.wert == wert) {		//wenn der wert vom nchsten Node gleich der wert ist 
				current.next = current.next.next;	//der nchste wert von Node wir auf den bernchsten gesetzt 
				size--;								//gre der Node wird eins runter gezhlt um den eintrag zu lschen 
			}
			current = current.next;					//Node wird wieder eins hochgezhlt 
		}
	}

	public void Ausgabe() {							//Ausgabe Methode 
		Node<P> current = this.start;				//Neuer Node wird erstellt 

		while (current != null) {					//solange der Node current ungleich null ist 
			System.out.print(current.wert + " ");	//ausgabe 
			current = current.next;					//current wird auf den nchsten Node gesetzt
		}
		System.out.print("\n");						//ausgabe 
	}

	public int size() { // getter Mehode f¸r grˆﬂe		
		return this.size;
	}

	public Node<P> getStart() { // getter Mehode f¸r Start	
		return this.start;
	}

	public Set<P> intersection(Set<P> s) {		//Intersection Methode 
		Set<P> result = new Set<P>();			//neuees set "result" wird ertsellt 
		Node<P> current = this.start;				//neuer Node current wird erstellet 
		while (current != null) {					//solange current ungleich null ist 
			if (s.contains(current.wert))			// wenn sn den wert von current hat 
				result.add(current.wert);			//soll am result der wert hinzugefgt werden 
			current = current.next;					//current wird wieder hochgezhlt 
		}	
		return result;								//result wird returned
	}

	public Set<P> union(Set<P> s) {  								//Methode schreibt beide werte aus beiden Listen zusammen
		Node<P> current = this.start; 								//erstellt erste Liste
		Node<P> current2 = s.start; 								//erstellt zweite Liste
		Set<P> result = new Set<P>(); 								//erstellt dritte Liste

		result.add(current.wert); 									//fgt wert hinzu 

		for (int i = 0; i < this.size(); i++) {						 //erste liste wird durchgegangen 
			for (int j = 0; j < s.size(); j++) { 					//zweite Liste wird durchgegangen
				if (result.contains(current.wert) == false) { // wenn result bereits den wert enthlt wird er nicht
																// hinzugefgt
					result.add(current.wert); 						//fht wert ein 
				}
				if (result.contains(current2.wert) == false) { // wenn result bereits den wert enthlt wird er nicht
																// hinzugefgt
					result.add(current2.wert); 					//fgt wert ein 
				}
				current2 = current2.next; 						//zhlt auf die nchste variable hoch in der zweiten liste
				
			}
			current = current.next; 							// zhlt auf die nchste variable in der ersten liste hoch
			current2 = s.start;									 // current der zweiten liste wird zum start der zweiten eingegebenen liste
		}
		return result; 											// gibt result zurck worin die listen gerspeichert sind 
	}
	
	public Set<P> difference(Set<P> s) {						//Methode wird erstellt und difference benannt 	
		Node<P> current = this.start;							// neue Node "current " erstellt und die werte von start eingefgt 
		Set<P> result = new Set<P>();							//neuer Set " result " wird erstellt 

		for (int i = 0; i < this.size(); i++) {					//for schleife geht die erste variable  durch 
			for (int j = 0; j < s.size(); j++) {				//for schleife geht zweite variable durch 
													
					if (s.contains(current.wert) == false) {	//wenn s denn jetztigen wert nicht hat 
						result.add(current.wert);					//soll an result der jetzige wert hinzugefgt werden 
					}
			}
			current = current.next;								//zhlt weiter 
			
		}
		return result;											//gibt result zutck 
	}
	public boolean subset(Set<P> s) {   						//neue Methode "subeset"
        Node<P> current2 = s.start;								//neue Node "current2" wird auf start wert von s gesetzt 
        
        while(current2 != null) { 								//solange current 2 ungleich null ist 
            if(this.contains(current2.wert) == true) {			// wenn this denn jetzigen wert hat 
                 current2 = current2.next;						//current wird eins weiter gesetzt 
            } else {											//sonst
                return false;									// soll falls zurckgegeben werden 
            }
        }
        return true;											//wenn obere while schleife nicht erfllt weird soll es true zurckgeben 

    }
			
				 
		}
			 
	


